diff --git a/tests/drivers/watchdog/wdt_basic_api/src/test_wdt.c b/tests/drivers/watchdog/wdt_basic_api/src/test_wdt.c
index 482bdb48ef7a5..4c529837b3fd9 100644
--- a/tests/drivers/watchdog/wdt_basic_api/src/test_wdt.c
+++ b/tests/drivers/watchdog/wdt_basic_api/src/test_wdt.c
@@ -300,7 +300,7 @@ static int test_wdt_bad_window_max(void)
 
 void test_wdt(void)
 {
-	if (m_testcase_index != 1) {
+	if (m_testcase_index == 0) {
 		zassert_true(test_wdt_no_callback() == TC_PASS, NULL);
 	}
 	if (m_testcase_index == 1) {
@@ -322,6 +322,7 @@ void test_wdt(void)
 		m_testcase_index++;
 	}
 	if (m_testcase_index > 3) {
+		m_testcase_index = 0;
 		m_state = WDT_TEST_STATE_IDLE;
 	}
 }
